
# Damien Leroy - UCLouvain
# June, 2008

import re, shutil, sys, regexplace

# dir : directory where files have to be found
# file_expr : expression for files
# prefixes, a list of "prefix" objects
def convert(dir, file_expr, prefixes = []) :


    def convert_rule(match) :
        colors_str = match.group(1)
        rule = match.group(2)
        separator =  match.group(3)

        # colors in a square list, i_th element contain the list of color
        # for i_th match
        colors = [ ] 
        for col in colors_str.split(";") :
            colors.append(prefixes_with_color(col.split(",")))
           
        rulelist = [rule]
        
        # replace in ordered by color
        for colnum in range(0,len(colors)):
            
            color = colors[colnum]
            newrulelist = []
           
            for prefix in color :  
                for onerule in rulelist :
                    def convert_match(match): 
                        function = match.group(1)[0:-1]
                        return prefix.get(function)
                        
                    newrulelist.append(
                        re.sub( '\$([a-zA-Z0-9\-_]*:|)?'+
                        (str(colnum),"0?")[colnum == 0]
                        +'\$', convert_match, onerule ))
               
            rulelist = newrulelist
                
                
        return separator.replace("\\n","\n").join(rulelist)

    def prefixes_with_color(collist) :
        
        preflist = []

        for p in prefixes :
            if p.hasColorFromList(collist) :
                preflist.append(p)
            
        return preflist

    regexplace.do( dir, file_expr, 
    '\[([^\[]*)\[([^\]]*)\]([^\]]*)\]', convert_rule )
    
class Prefix : 
        
    colors = []
    value = ""
    
    def __init__(self, v=""):
        self.value = v
    
    def hasColorFromList(self, collist) :

        for col in collist :
            if col == "" or col in self.colors : # color "" is all
                return 1
            
        return 0

    def get(self, fct = "") :
        
        def reverse_addr() : 
    
            output = ""
            parts = self.value.split(":")
            
            if len (parts) > 1 :    # v6
                parts.reverse()
                for part in parts :
                    for i in range(len(part),0,-1) : output += part[i-1]+"."
                    for i in range(4-len(part)): output += "0."
                    
            else :     #v4
                parts = self.value.split(".")
                parts.reverse()
                for part in parts: output += part+"."
                    
            return output[0:-1]
        # end reverse_addr

        def default_val() : return self.value

        return {
            'reverse': reverse_addr
            }.get(fct,default_val)()

    

if __name__ == '__main__':
    convert("../../data/", "testfile", [ Prefix("130.104"), Prefix("1.1")  ] )
