# Stefano Spinucci
# 2006-02-07 (rev 4)

# thanks to roadrunner.py
# http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/52553
# for some ideas and some code

# tested with python 2.3.5



import sys, os, re, string



# pupulate and return 'fileslist[]' with all files inside 'dir' matching 'regx'
def make_files_list(dir, regx):

    # if dir is not a directory, exit with error
    if not os.path.isdir(dir):
        sys.exit(dir + ' is not a valid dir to walk !!!')

    # compile the search regexp
    cregex=re.compile(regx)

    # initialize the file list
    fileslist = []

    # loop on all files and select files matching 'regx'
    for root, dirs, files in os.walk(dir):
        for name in files:
            if cregex.search(name):
                path = os.path.join(root, name)
                fileslist.append(path)

    # return the file list
    return fileslist[:]



# in all files in 'fileslist' search the regexp 'searchregx' and replace
# with 'replacestring';
def replace_in_files(fileslist, searchregx, replacestring):

    # compile regexp
    cregex=re.compile(searchregx)

    # loop on all files
    for xfile in fileslist:

        # initialize the replace flag
        replaceflag=0

        # open file for read  
        readlines=open(xfile,'r').readlines()
        # intialize the list counter
        listindex = -1

        # search and replace in current file printing to the user changed lines
        for currentline in readlines:

            # increment the list counter
            listindex = listindex + 1

            # if the regexp is found
            if cregex.search(currentline):

                # make the substitution
                f=re.sub(searchregx,replacestring,currentline)


                # update the whole file variable ('readlines')
                readlines[listindex] = f
                replaceflag=1
                            
        # if some text was replaced
        # overwrite the original file
        if replaceflag==1:

            # open the file for writting  
            write_file=open(xfile,'w') 

            # overwrite the file  
            for line in readlines:
                write_file.write(line)

            # close the file
            write_file.close()


def do(dirname, files_regext, search_regexp, replacestr):

    # make the file list
    fileslist = make_files_list(dirname, files_regext)

    replace_in_files(fileslist, search_regexp, replacestr)        
                
            

# main function
def main():

    # if parameters are wrong, exit with error
    if len(sys.argv) != 5:

        print '\nUsage:'
        print 'regexplace.py dirname files-regexp search-regexp replace-string'

        sys.exit(1)

    regexplace(sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4])
            
if __name__ == '__main__':
    main()