# Damien Leroy - UCLouvain
# June, 2008

import re
from Prefix import Prefix
from regexfile import regexfile

# srcfile : source paramated file 
# dstfile : output file that will be created (or overwritten)
# prefixes, a list of "prefix" objects
def convert(srcfile, dstfile, prefixes = []) :


    def convert_rule(match) :
        colors_str = match.group(1)
        rule = match.group(2)
        separator =  match.group(3)

        # colors in a square list, i_th element contain the list of prefixes
        # for i_th match
        colors = [ ] 
        for col in colors_str.split(";") :
            colors.append(prefixes_with_color(col.split(",")))
           
        rulelist = [rule]
        
        
        # replace in ordered by color
        for colnum in range(0,len(colors)):
            
            color = colors[colnum]
            newrulelist = []
           
            for prefix in color :  
                for onerule in rulelist :
                    def convert_match(match): 
                        function = match.group(1)[0:-1]
                        return prefix.get(function)
                        
                    newrulelist.append(
                        re.sub( '\$([a-zA-Z0-9\-_]*:|)?'+
                        (str(colnum),"0?")[colnum == 0]
                        +'\$', convert_match, onerule ))
               
            rulelist = newrulelist
                
                
        return separator.replace("\\n","\n").join(rulelist)

    def prefixes_with_color(collist) :
        
        preflist = []

        for p in prefixes :
            if p.hasColorFromList(collist) :
                preflist.append(p)
            
        return preflist

	# 2 times to permit imbricated pattern
    regexfile( srcfile, "/tmp/prefixtransftmp", 
    '\[([^\[]*)\[([^\]\[]*)\]([^\]]*)\]', convert_rule )
    regexfile( "/tmp/prefixtransftmp", dstfile, 
    '\[([^\[]*)\[([^\]\[]*)\]([^\]]*)\]', convert_rule )
    
