# Damien Leroy - UCLouvain
# June, 2008

class Prefix : 
        
    colors = []
    value = ""
    ttl = -1  # <0 means 'not set'/default
	    
    # val is the "address value" of the prefix, e.g. 130.104 or 2001:6a8:3080
    # colors is a list of the colors of this prefix
    # ttl 
    def __init__(self, val="", colors=[], ttl=-1):
        self.value = val
        self.colors = colors
        self.ttl = ttl
    
    def recover(self, prefix):
        self.value = prefix.value
        if "colors" in prefix._keys() : self.colors = prefix.colors
        if "ttl" in prefix._keys() : self.ttl = prefix.ttl
    
    def hasColorFromList(self, collist) :

        for col in collist :
            if col == "" or col in self.colors : # color "" is all
                return 1
            
        return 0

    def get(self, fct = "") :
        
        def reverse_addr() : 
    
            output = ""
            parts = self.value.split(":")
            
            if len (parts) > 1 :    # v6
                parts.reverse()
                for part in parts :
                    for i in range(len(part),0,-1) : output += part[i-1]+"."
                    for i in range(4-len(part)): output += "0."
                    
            else :     #v4
                parts = self.value.split(".")
                parts.reverse()
                for part in parts: output += part+"."
                    
            return output[0:-1]
        # end reverse_addr

        def ttl():
			if ttl >= 0 : return str(self.ttl)
			else : return ""
		
        def default_val() : return self.value

        return {
            'reverse': reverse_addr,
           	'ttl': ttl
            }.get(fct,default_val)()

    